var utils = implement("fiskheroes:external/utils");

function init(hero) {
    hero.setName("Infinity Ultron");
    hero.setTier(10);

    hero.setHelmet("item.superhero_armor.piece.head");
    hero.setChestplate("item.superhero_armor.piece.torso");
    hero.setLeggings("item.superhero_armor.piece.legs");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("fiskheroes:vibranium_physiology", "fiskheroes:mind_stone", "smp:space_stone");
    hero.addAttribute("PUNCH_DAMAGE", 11.0, 0);
    hero.addAttribute("WEAPON_DAMAGE", 1.5, 0);
    hero.addAttribute("SPRINT_SPEED", 0.15, 1);
    hero.addAttribute("JUMP_HEIGHT", 1.0, 0);
    hero.addAttribute("FALL_RESISTANCE", 1.0, 1);

    hero.addKeyBind("CHARGED_BEAM", "key.mindStoneBlast", 1);
    hero.addKeyBind("INTANGIBILITY", "key.intangibility", 2);
    hero.addKeyBind("TELEKINESIS", "key.telekinesis", 3);
    hero.addKeyBind("SHIELD", "key.forcefield", 4);

    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setModifierEnabled(isModifierEnabled);

    hero.setHasProperty((entity, property) => property == "MASK_TOGGLE");
    hero.setDefaultScale(1.2);

    hero.setTickHandler((entity, manager) => {
        utils.flightOnIntangibility(entity, manager);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    if (entity.getData("fiskheroes:mask_open")) {
        return false;
    }

    switch (keyBind) {
    case "TELEKINESIS":
        return entity.getData("fiskheroes:beam_charge") == 0;
    case "SHIELD":
        return entity.getHeldItem().isEmpty() && !(entity.getData("fiskheroes:flying") && entity.isSprinting()) && !entity.getData("fiskheroes:telekinesis") && !entity.getData("fiskheroes:mask_open");
    default:
        return true;
    }
}

function isModifierEnabled(entity, modifier) {
    switch (modifier.name()) {
        case "fiskheroes:controlled_flight":
            return !entity.getData("fiskheroes:mask_open");
        default:
            return true;
    }
}