var landing = implement("fiskheroes:external/superhero_landing");

function init(hero) {
    hero.setName("Rainbow Defender");
    hero.setTier(6);
    
    hero.setHelmet("Helmet");
    hero.setChestplate("Chestplate");
    hero.setLeggings("Leggings");
    hero.setBoots("Boots");
    
    hero.addPowers("smp:defender_suit");
    hero.addAttribute("PUNCH_DAMAGE", 5.7, 0);
    hero.addAttribute("WEAPON_DAMAGE", 1.3, 0);
    hero.addAttribute("JUMP_HEIGHT", 2, 0);
    hero.addAttribute("FALL_RESISTANCE", 1.0, 1);
    hero.addAttribute("SPRINT_SPEED", 0.7, 1);
    hero.addAttribute("IMPACT_DAMAGE", 1.5, 1)
    hero.addAttribute("BASE_SPEED_LEVELS", 2, 0);
    hero.addAttribute("MAX_HEALTH", 7, 0);
    hero.addAttribute("WEAPON_DAMAGE", -0.95, 1);

    hero.addKeyBind("CHARGED_BEAM", "Defensive Blasts", 1);
    hero.addKeyBind("SHIELD", "key.naniteShield", 2);
    hero.addKeyBind("SENTRY_MODE", "Eject System", 3);

    hero.addSoundEvent("MASK_OPEN", "fiskheroes:mk50_mask_open");
    hero.addSoundEvent("MASK_CLOSE", "fiskheroes:mk50_mask_close");

    hero.setHasProperty((entity, property) => property == "MASK_TOGGLE");

    hero.setTickHandler((entity, manager) => {
        var flying = entity.getData("fiskheroes:flying");
        manager.incrementData(entity, "fiskheroes:dyn/booster_timer", 2, flying);

        var item = entity.getHeldItem();
        flying &= !entity.as("PLAYER").isUsingItem();
        manager.incrementData(entity, "fiskheroes:dyn/booster_r_timer", 2, flying && item.isEmpty() && !entity.isPunching() && entity.getData("fiskheroes:shield_blocking_timer") == 0);
        manager.incrementData(entity, "fiskheroes:dyn/booster_l_timer", 2, flying && !item.doesNeedTwoHands());

        landing.tick(entity, manager);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
        case "SHIELD":
            return !(entity.getData("fiskheroes:flying") && entity.isSprinting());
        default:
            return true;
    }
}