extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:potato_layer1",
    "layer2": "smp:potato_layer2",
    "cape": "smp:potato_cape",
    "mouth": "smp:potato_mouth"
});
var utils = implement("fiskheroes:external/utils");
var capes = implement("fiskheroes:external/capes");

var cape;
var mouth;

function initEffects(renderer) {
 var color = 0x024050;
var beam = renderer.createResource("BEAM_RENDERER", "fiskheroes:mysterio_beam");
utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:war_cry", "head", 0xEFEAB5, [
    { "firstPerson": [0, 0, 0], "offset": [0, 0.25, 1.0], "size": [2.0, 2.0] }
]);

utils.bindBeam(renderer, "fiskheroes:energy_projection", beam, "head", 0xEFEAB5, [
    { "firstPerson": [2.2, 0.0, 2.0], "offset": [2.2, -4, -4.0], "size": [2.5, 0.5] },
    { "firstPerson": [-2.2, 0.0, 2.0], "offset": [-2.2, -4, -4.0], "size": [2.5, 0.5] }
]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_energy_projection"));

var physics = renderer.createResource("CAPE_PHYSICS", null);
    physics.maxFlare = 0.4;
    cape = capes.createDefault(renderer, 24, "fiskheroes:cape_default.mesh.json", physics);
    cape.effect.texture.set("cape");
    cape.effect.width = 12;

    mouth = renderer.createEffect("fiskheroes:overlay");
    mouth.texture.set("mouth");
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    utils.addFlightAnimationWithLanding(renderer, "iron_man.FLIGHT", "fiskheroes:flight/iron_man.anim.json");
    utils.addHoverAnimation(renderer, "mmcw.HOVER", "fiskheroes:flight/idle/neutral");
    utils.addAnimationEvent(renderer, "FLIGHT_DIVE", "fiskheroes:iron_man_dive");

    renderer.removeCustomAnimation("basic.ENERGY_PROJ");

    addAnimationWithData(renderer, "iron_man.LAND", "fiskheroes:superhero_landing", "fiskheroes:dyn/superhero_landing_timer")
        .priority = -8;

    addAnimationWithData(renderer, "iron_man.ROLL", "fiskheroes:flight/barrel_roll", "fiskheroes:barrel_roll_timer")
        .priority = 10;
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (!isFirstPersonArm && renderLayer == "CHESTPLATE") {
        cape.render(entity);
    }
    if (renderLayer == "HELMET" && entity.getData("fiskheroes:beam_shooting")) {
        mouth.render();
    }
}