extend("fiskheroes:hero_basic"),
loadTextures({
    "layer1": "smp:speedburst_layer1",
    "layer2": "smp:speedburst_layer2"
});

var utils = implement("fiskheroes:external/utils");
var speedster = implement("fiskheroes:external/speedster_utils");

function init(renderer) {
    parent.init(renderer);
    renderer.setTexture((entity, renderLayer) => {
        if (renderLayer == "HELMET" && (entity.isDisplayStand() || entity.isBookPlayer() ? entity.getData("fiskheroes:mask_open") : entity.getData("fiskheroes:mask_open_timer2") > 0.35)) {
            return "layer2";
        }
        return renderLayer == "LEGGINGS" ? "layer2" : "layer1";
    });
}

function initEffects(renderer) {
    utils.bindTrail(renderer, "smp:lightning_speedburst");

    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:lightning_sword_cast", "rightArm", 0xDDAC17, [
        { "firstPerson": [-8.0, -9, -10.0], "offset": [-0.5, 9.0, -15.0], "size": [1.0, 1.0] }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_energy_projection"));

    utils.bindBeam(renderer, "fiskheroes:lightning_cast", "fiskheroes:lightning_cast", "rightArm", 0xDDAC17, [
        { "firstPerson": [-8.0, 4.5, -10.0], "offset": [-0.5, 9.0, 0.0], "size": [0.75, 0.75] }
    ]);

    speedster.init(renderer);

    lightning = utils.createLines(renderer, ("BEAM_RENDERER", "smp:lightning_sword"), 0xDDAC17, [
        {"start": [0, 0, 4], "end": [0, 0, -18], "size": [5.0, 5.0]}]);
    
    lightning.anchor.set("rightArm");
    lightning.setOffset(1.0, 9.0, 2.0);
    lightning.setScale(1.0);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    addAnimation(renderer, "speedburst.MASK", "fiskheroes:remove_cowl")
        .setData((entity, data) => {
            var f = entity.getInterpolatedData("fiskheroes:mask_open_timer2");
            data.load(f < 1 ? f : 0);
        });

    addAnimation(renderer, "speedburst.BEAM", "fiskheroes:aiming_fpcorr").setData((entity, data) => data.load(Math.max(entity.getInterpolatedData("fiskheroes:beam_charge") * 5 - 4, 0)));
}

function render(entity, renderLayer, isFirstPersonArm) {
    lightning.render();
    lightning.opacity = entity.getInterpolatedData("fiskheroes:blade_timer");
}